"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _link = require("next/dist/lib/link.js");

var _link2 = _interopRequireDefault(_link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Form(_ref) {
  var user = _ref.user,
      options = _ref.options,
      onChange = _ref.onChange,
      onSubmit = _ref.onSubmit,
      error = _ref.error;

  // Reuse the auth0 css to build a form to create a user
  return _react2.default.createElement("div", { className: "auth0-lock auth0-lock-opened" }, _react2.default.createElement("div", { className: "auth0-lock-overlay" }), _react2.default.createElement("div", { className: "auth0-lock-center" }, _react2.default.createElement("form", { className: "auth0-lock-widget", onSubmit: onSubmit }, _react2.default.createElement("div", { className: "auth0-lock-widget-container" }, _react2.default.createElement("div", { className: "auth0-lock-cred-pane auth0-lock-quiet" }, _react2.default.createElement("div", { className: "auth0-lock-header" }, _react2.default.createElement("div", { className: "auth0-lock-header-bg auth0-lock-blur-support" }, _react2.default.createElement("div", { className: "auth0-lock-header-bg-blur", style: { backgroundImage: "url('" + options.theme.logo + "')" } }), _react2.default.createElement("div", { className: "auth0-lock-header-bg-solid", style: { backgroundColor: options.theme.primaryColor } })), _react2.default.createElement("div", { className: "auth0-lock-header-welcome" }, _react2.default.createElement("img", { className: "auth0-lock-header-logo", src: options.theme.logo }), _react2.default.createElement("div", { className: "auth0-lock-name" }, options.languageDictionary.title))), error && _react2.default.createElement("div", { className: "auth0-global-message auth0-global-message-error" }, error.message || 'There was an error!'), _react2.default.createElement("div", { className: "auth0-lock-view-content" }, _react2.default.createElement("div", { className: "auth0-lock-body-content" }, _react2.default.createElement("div", { className: "auth0-lock-content" }, _react2.default.createElement("div", { className: "auth0-lock-form" }, user.picture && _react2.default.createElement("img", { src: user.picture, style: { display: 'block', margin: '0 auto 10px auto', width: 60, height: 60, borderRadius: '100%' } }), _react2.default.createElement("p", null, _react2.default.createElement("span", { style: { fontWeight: 'bold', display: 'block' } }, "Hello, it looks like you are new here!"), _react2.default.createElement("span", null, "Create a profile to continue...")), _react2.default.createElement("div", { className: "auth0-lock-input-block" }, _react2.default.createElement("div", { className: "auth0-lock-input-wrap auth0-lock-input-wrap-with-icon" }, _react2.default.createElement("span", null, _react2.default.createElement("i", { style: { position: 'absolute', left: 13, top: 12, color: '#999' }, className: "fa fa-id-card" })), _react2.default.createElement("input", { type: "text", name: "name", className: "auth0-lock-input", placeholder: "Your Name", value: user.name, onChange: onChange }))), _react2.default.createElement("div", { className: "auth0-lock-input-block" }, _react2.default.createElement("div", { className: "auth0-lock-input-wrap auth0-lock-input-wrap-with-icon" }, _react2.default.createElement("span", null, _react2.default.createElement("i", { style: { position: 'absolute', left: 13, top: 12, color: '#999' }, className: "fa fa-envelope" })), _react2.default.createElement("input", { type: "email", name: "email", className: "auth0-lock-input", placeholder: "yours@example.com", autoCapitalize: "off", value: user.email, onChange: onChange }))), _react2.default.createElement("div", { className: "auth0-lock-input-block" }, _react2.default.createElement("div", { className: "auth0-lock-input-wrap auth0-lock-input-wrap-with-icon" }, _react2.default.createElement("span", null, _react2.default.createElement("i", { style: { position: 'absolute', left: 13, top: 12, color: '#999' }, className: "fa fa-at" })), _react2.default.createElement("input", { type: "text", name: "username", className: "auth0-lock-input", placeholder: "username", value: user.username, onChange: onChange }))), _react2.default.createElement("p", { className: "auth0-lock-alternative" }, _react2.default.createElement(_link2.default, { href: { query: { action: 'verify' } } }, _react2.default.createElement("a", { className: "auth0-lock-alternative-link" }, "Already have a profile?"))))))), _react2.default.createElement("button", { className: "auth0-lock-submit", type: "submit", style: { backgroundColor: options.theme.primaryColor } }, _react2.default.createElement("span", { className: "auth0-label-submit" }, "Create Profile", _react2.default.createElement("span", null, _react2.default.createElement("svg", { focusable: "false", className: "icon-text", width: "8px", height: "12px", viewBox: "0 0 8 12", version: "1.1", xmlns: "http://www.w3.org/2000/svg" }, _react2.default.createElement("g", { id: "Symbols", stroke: "none", strokeWidth: "1", fill: "none", fillRule: "evenodd" }, _react2.default.createElement("g", { id: "Web/Submit/Active", transform: "translate(-148.000000, -32.000000)", fill: "#FFFFFF" }, _react2.default.createElement("polygon", { id: "Shape", points: "148 33.4 149.4 32 155.4 38 149.4 44 148 42.6 152.6 38" }))))))))))));
}

exports.default = Form;