'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _head = require('next/dist/lib/head.js');

var _head2 = _interopRequireDefault(_head);

var _index = require('next/dist/lib/router/index.js');

var _index2 = _interopRequireDefault(_index);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _defaultsDeep = require('lodash/defaultsDeep');

var _defaultsDeep2 = _interopRequireDefault(_defaultsDeep);

var _Lock = require('./Lock');

var _Lock2 = _interopRequireDefault(_Lock);

var _Layout = require('./Layout');

var _Layout2 = _interopRequireDefault(_Layout);

var _Form = require('./Form');

var _Form2 = _interopRequireDefault(_Form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOptions = {
  languageDictionary: {
    title: 'Auth 0'
  },
  theme: {
    primaryColor: '#FF6300',
    logo: '//cdn.auth0.com/styleguide/1.0.0/img/badge.png'
  }
};

// The login page will either show a login form or handle the login and user creation process when returning from auth

var Login = function (_React$Component) {
  (0, _inherits3.default)(Login, _React$Component);

  function Login(props) {
    (0, _classCallCheck3.default)(this, Login);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Login.__proto__ || (0, _getPrototypeOf2.default)(Login)).call(this, props));

    _this.routerChange = function (url) {
      _this.setState({ action: _index2.default.query.action || 'login' });
    };

    _this.onLock = function (component) {

      _this.lock = component && component.lock;

      if (_this.lock) {
        // Set action from url, default to 'login'
        _this.setState({ action: _index2.default.query.action || 'login' });
      } else {
        // Something went wrong
        _this.setState({ action: 'error' });
      }
    };

    _this.onAuthenticated = function (authResult) {
      _this.lock && _this.lock.getUserInfo(authResult.accessToken, function (error, profile) {
        //console.log('authenticated',authResult, profile, error);

        if (error) {
          _this.lock && _this.lock.show({
            flashMessage: {
              type: 'error',
              text: 'Invalid Token'
            }
          });
        } else {

          if (_this.props.onAuthenticated) {
            _this.props.onAuthenticated(authResult, profile, function (user, err) {
              if (err) {
                _this.lock && _this.lock.show({
                  flashMessage: {
                    type: 'error',
                    text: err.message || 'There was an unknown error!'
                  }
                });
              } else {
                // If onAuthenticated returns a user then set default state for form and redirect to create
                _this.setState({ user: user, authResult: authResult, profile: profile }, function () {
                  _index2.default.push({ pathname: _index2.default.pathname, query: { action: 'create' } });
                });
              }
            });
          } else {
            // Just redirect
            _index2.default.push('/');
          }
        }
      });
    };

    _this.onError = function (error) {
      //console.log('auth error', error);

      _this.lock && _this.lock.show({
        flashMessage: {
          type: 'error',
          text: 'There was an error, please try again.'
        }
      });
    };

    _this.onFormChange = function (event) {
      _this.setState({ user: (0, _extends3.default)({}, _this.state.user, (0, _defineProperty3.default)({}, event.target.name, event.target.value)) });
    };

    _this.onFormSubmit = function (event) {
      event.preventDefault();
      _this.props.onCreate && _this.props.onCreate(_this.state.user, _this.state.authResult, function (error) {
        if (error) {
          _this.setState({ error: error });
        } else {
          _index2.default.push('/');
        }
      });
    };

    _this.layout = function (_ref) {
      var lock = _ref.lock;
      var _this$state = _this.state,
          action = _this$state.action,
          user = _this$state.user,
          error = _this$state.error;
      var options = _this.props.options;

      switch (action) {
        case 'create':
          if (user) {
            return _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Create')), _react2.default.createElement(_Form2.default, { options: (0, _defaultsDeep2.default)(options, defaultOptions), user: user, error: error, onChange: _this.onFormChange, onSubmit: _this.onFormSubmit }));
          } else {
            return _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Authenticating...')));
          }
        case 'password':
          return _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Change Password')));
        case 'verify':
          return _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Verify Credentials')));
        case 'error':
          return _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Error')));
        default:
          return _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Login')));
      }
    };

    _this.state = {
      action: null, // action from url 
      user: null, // create user data
      authResult: null, // auth tokens etc.
      error: null // user create error
    };
    return _this;
  }

  (0, _createClass3.default)(Login, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // Listen for route changes
      _index2.default.router.events.on('routeChangeComplete', this.routerChange);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // Stop listening
      _index2.default.router.events.off('routeChangeComplete', this.routerChange);
    }

    // We need to wait for a lock to be available before we do anything

  }, {
    key: 'componentDidUpdate',

    // We should always get a componentDidUpdate as the lock will trigger a state change when its ready.
    value: function componentDidUpdate(prevProps, prevState) {
      if (!this.lock) {
        return;
      }
      if (window.location.hash) {
        // We are returning from auth, it will handle onAuth event
        return;
      }

      if (this.state.action === 'create' && !this.state.user) {
        // If we are doing a create check we are logged in by looking at the user that was set.
        _index2.default.push({ pathname: _index2.default.pathname, query: { action: 'login' } });
      }

      if (this.state.action !== prevState.action) {
        switch (this.state.action) {
          case 'create':
            // don't open on create
            break;
          case 'verify':
            this.lock.show({
              initialScreen: 'login',
              flashMessage: {
                type: 'error',
                text: 'Check the account credentials that you created your profile with are correct or login with a different account.'
              }
            });
            break;
          case 'password':
            this.lock.show({
              initialScreen: 'forgotPassword'
            });
            break;
          case 'signup':
            this.lock.show({
              initialScreen: 'signUp'
            });
            break;
          default:
            this.lock.show({
              initialScreen: 'login'
            });
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          auth0Id = _props.auth0Id,
          auth0Domain = _props.auth0Domain,
          options = _props.options;

      return _react2.default.createElement(_Lock2.default, { ref: this.onLock, onError: this.onError, onAuthenticated: this.onAuthenticated, options: (0, _extends3.default)({}, (0, _defaultsDeep2.default)(options, defaultOptions), { closable: false, autoclose: false }), layout: this.layout, auth0Id: auth0Id, auth0Domain: auth0Domain }, _react2.default.createElement(_Layout2.default, null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Initialising...'))));
    }
  }]);

  return Login;
}(_react2.default.Component);

Login.defaultProps = {
  options: {}
};

exports.default = Login;