'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactApollo = require('react-apollo');

var _nextApolloProvider = require('next-apollo-provider');

var _nextApolloProvider2 = _interopRequireDefault(_nextApolloProvider);

var _authMiddleware = require('./authMiddleware');

var _authMiddleware2 = _interopRequireDefault(_authMiddleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _nextApolloProvider2.default)(function (initialState, ssrMode, context) {
  //console.log('process.env.GRAPHQL_URL',process.env.GRAPHQL_URL);
  var networkInterface = (0, _reactApollo.createNetworkInterface)({
    uri: process.env.GRAPHQL_URL,
    opts: {
      credentials: 'same-origin'
    }
  });

  networkInterface.use([_authMiddleware2.default]);

  var clientSettings = {
    initialState: initialState,
    ssrMode: ssrMode,
    connectToDevTools: process.browser && false,
    dataIdFromObject: function dataIdFromObject(result) {
      return result.id || null;
    },
    networkInterface: networkInterface
  };

  return clientSettings;
});