'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _index = require('next/dist/lib/router/index.js');

var _index2 = _interopRequireDefault(_index);

var _withApollo = require('../lib/withApollo');

var _withApollo2 = _interopRequireDefault(_withApollo);

var _Login = require('../components/Login');

var _Login2 = _interopRequireDefault(_Login);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  query($auth0UserId: String!) {\n    User(auth0UserId:$auth0UserId){\n      id\n      name\n    }\n  }\n'], ['\n  query($auth0UserId: String!) {\n    User(auth0UserId:$auth0UserId){\n      id\n      name\n    }\n  }\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  mutation ($username: String!, $email: String!, $picture: String!, $name: String!, $authProvider: AuthProviderSignupData!) {\n    createUser(username: $username, email: $email, picture: $picture, name: $name, authProvider: $authProvider) {\n      # We are not authenticated yet so can only get public fields on this request!\n      id\n      name\n      username\n      picture\n    }\n  }\n'], ['\n  mutation ($username: String!, $email: String!, $picture: String!, $name: String!, $authProvider: AuthProviderSignupData!) {\n    createUser(username: $username, email: $email, picture: $picture, name: $name, authProvider: $authProvider) {\n      # We are not authenticated yet so can only get public fields on this request!\n      id\n      name\n      username\n      picture\n    }\n  }\n']);

var LoginPage = function (_React$Component) {
  (0, _inherits3.default)(LoginPage, _React$Component);

  function LoginPage(props) {
    (0, _classCallCheck3.default)(this, LoginPage);

    var _this = (0, _possibleConstructorReturn3.default)(this, (LoginPage.__proto__ || (0, _getPrototypeOf2.default)(LoginPage)).call(this, props));

    _this.onAuthenticated = function (authResult, profile, callback) {
      //console.log(authResult, profile);

      // Do checks such as email validation, account suspeneded etc.
      if (!profile.email_verified) {
        var err = {
          message: 'Please check your email and validate your email address.'
        };
        callback(null, err);
      } else {
        // Check we have a user in the db
        _this.props.apolloClient.query({
          query: userQuery,
          variables: {
            auth0UserId: profile.user_id
          }
        }).then(function (query) {
          if (query.data && query.data.User) {
            // We have a user, just save the auth token and redirect
            try {
              window.localStorage.setItem("auth0AccessToken", authResult.accessToken);
              window.localStorage.setItem('auth0IdToken', authResult.idToken);
              window.localStorage.setItem("auth0Profile", (0, _stringify2.default)(profile));

              // Redirect
              _index2.default.push('/');
            } catch (err) {
              callback(null, { message: 'You must allow your browser to use local storage to login.' });
            }
          } else {
            // We dont have a user so pass the profile data to the callback to initiate create
            // You could create a user in the db here to skip the create step
            callback({
              name: profile.name.split('@')[0].replace(/\b\w/g, function (l) {
                return l.toUpperCase();
              }), // ensure name is not an email address and capitalize
              email: profile.email,
              username: profile.nickname,
              picture: profile.picture
            });
          }
        }).catch(function (err) {
          callback(null, err);
        });
      }
    };

    _this.onCreate = function (user, authResult, callback) {
      console.log('onCreate', user, authResult);

      _this.props.createUserMutation({ variables: {
          username: user.username,
          name: user.name,
          email: user.email,
          picture: user.picture,
          authProvider: { auth0: { idToken: authResult.idToken } }
        } }).then(function (result) {
        _index2.default.replace(window.localStorage.getItem('auth0Redirect') || '/');
      }).catch(function (errors) {
        console.log('mutationError', errors);
        var error = new Error();

        if (errors.graphQLErrors && errors.graphQLErrors.length > 0) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = (0, _getIterator3.default)(errors.graphQLErrors), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var gqlError = _step.value;

              if (gqlError.message.includes('User already exist')) {
                error.message = 'User already exists!';
              } else {
                error.message = 'There was an error, please check details and try again.';
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          error.message = 'There was an unknown error, please check details and try again.';
        }

        callback(error);
      });
    };

    return _this;
  }

  // Do something with the authResult - use the callback to continue to create user or throw error


  // Create a user in the db and return


  (0, _createClass3.default)(LoginPage, [{
    key: 'render',
    value: function render() {

      var options = {
        languageDictionary: {
          title: 'My Site'
        },
        theme: {
          primaryColor: '#FF0000'
        }
      };

      return _react2.default.createElement(_Login2.default, { options: options, onAuthenticated: this.onAuthenticated, onCreate: this.onCreate, auth0Id: process.env.AUTH0_ID, auth0Domain: process.env.AUTH0_DOMAIN });
    }
  }]);

  return LoginPage;
}(_react2.default.Component);

var userQuery = (0, _reactApollo.gql)(_templateObject);

var createUserMutation = (0, _reactApollo.gql)(_templateObject2);

exports.default = (0, _reactApollo.compose)(_withApollo2.default, (0, _reactApollo.graphql)(createUserMutation, { name: 'createUserMutation' }))(LoginPage);